
#define MAIN_APPLICATION
#include <stdlib.h>

#include <math.h>
#include <xc.h>
#include "config.h"
#include "rgb_matrix.h"
#include "matrix_gfx.h"
#include "config.h"
#include "pt_cornell_1_2.h"
#include "matrix_tests.h"
#include "adc_intf.h"

struct pt pt_update_matrix, pt_mood, pt_read_temperature, pt_heart, pt_changetemp;
char heartrate[60];
char temp[60];
char temp_f[60];
char buffer[60];
char test[60];
#define SYS_FREQ 40000000
#define HEART BIT_15
#define HEARTAN 9
#define TEMP BIT_13
#define TEMPAN 11


//index to track current mood mode
int mood_select = 2;
//current mood button mode for FSM
int button_state = 0;
int button_input = 0;

int temp_state = 0;

//push button state
#define NoPush 0
#define MaybePush 1
#define Pushed 2

//push button state for temperature
#define NoPush_t 0
#define MaybePush_t 1
#define Pushed_t 2

//mood mode state
#define HAPPY 0
#define SAD 1
#define NEUTRAL 2
#define ANGRY 3
#define EXCITED 4
#define SLEEP 5
#define HAPPY_N 6
//temp mode state
#define CELSIUS 0
#define FAHRENHEIT 1

//variable to store temperature value in Celsius and Fahrenheit
float temperature = 0;
float temperature_fahrenheit = 0;
//current temperature button mode for FSM
int temp_signal = 0;
int button_change = 0;
int button_chage_state = 0;

//time stamp for BPM calculation
int lastTime = 0;
int BPMTiming = 0;
//label the active beat
int BeatComplete = 0;
//current analog value read from pin
static int Signal = 0;
static int UpperThreshold = 550;
static int LowerThreshold = 450;
static int BPM = 0;
static int i = 0;

// === Update Matrix Thread ====================================================
//time for heart display
int sys_time = 0;
//time for angry animation display
int ang_time = 0;
//moving pet position and direction
int face_position_x = 4;
int face_position_y = 5;
int direction = 0;
//fixed pet position
int fixed_face_position_x = 5;
int fixed_face_position_y = 5;
//happy mood and sad mood animation state
int sad_mood = 0;
int happy_mood = 0;
//time stamp for neutral state
int neu_happy = 0;


static PT_THREAD(protothread_update_matrix(struct pt *pt)) {
    PT_BEGIN(pt);

    while (1) {
        //yield time 500 msec
        PT_YIELD_TIME_msec(500);
        //check direction of moving pet
        if (direction == 0) {
            face_position_x++;
            //if the pet is approaching the border of the area, change to another direction
            if (face_position_x == 10) {
                direction = 1;
            }
        } else {
            face_position_x--;
            //if the pet is approaching the border of the area, change to another direction
            if (face_position_x == 0) {
                direction = 0;
            }
        }
//refresh buffer for storing matrix information
        matrix_swapBuffers(false);
        //select mode and draw corresponding pattern on LED matrix
        switch (mood_select) {
            case EXCITED:
                //clear corresponding part
                matrix_fillRect(0, 5, 20, 12, matrix_color333(0, 0, 0));
                matrix_fillRect(25, 0, 7, 7, matrix_color333(0, 0, 0));
                //draw face on the corner to show the current select mode
                draw_happy_face(28, 3, matrix_color333(0, 0, 7), matrix_color333(7, 7, 0));
                //move the pet horizontally
                draw_pet(face_position_x, face_position_y, matrix_color333(7, 7, 7));
                draw_pet_happy_face(face_position_x, face_position_y, matrix_color333(7, 7, 0), matrix_color333(7, 7, 0));
                move_feet(face_position_x, face_position_y + 9, matrix_color333(7, 7, 7));
                move_right_hand(face_position_x + 8, face_position_y + 7, face_position_x, face_position_y, matrix_color333(7, 0, 7));
                move_left_hand(face_position_x, face_position_y + 7, face_position_x - 1, face_position_y, matrix_color333(7, 0, 7));
                //if temperature in Celsius is over 26 or the BPM is over 125, change to TIRED or EXCITED mode
                if (temperature > 26) mood_select = 5;
                else if(BPM < 125)  mood_select = 2;
                break;
                
            case HAPPY:
                 //clear corresponding part
                matrix_fillRect(0, 5, 20, 12, matrix_color333(0, 0, 0));
                matrix_fillRect(25, 0, 7, 7, matrix_color333(0, 0, 0));
                //draw face on the corner to show the current select mode
                draw_happy_face(28, 3, matrix_color333(0, 7, 0), matrix_color333(7, 7, 7));
                draw_pet(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 7, 7));
                draw_pet_happy_face(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 7, 0), matrix_color333(7, 7, 0));
                // the pet is in the fixed position
                move_feet(fixed_face_position_x, fixed_face_position_y + 9, matrix_color333(7, 7, 7));
                move_right_hand(fixed_face_position_x + 8, fixed_face_position_y + 7, fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 7));
                move_left_hand(fixed_face_position_x, fixed_face_position_y + 7, fixed_face_position_x - 1, fixed_face_position_y, matrix_color333(7, 0, 7));
                //if temperature in Celsius is over 26 or the BPM is over 125, change to TIRED or EXCITED mode
                if (temperature > 26) mood_select = 5;
                else if(BPM > 125)  mood_select = 4;
                //
                switch (happy_mood) {
                    case 0:
                        happy_expression1();
                        happy_mood++;
                        break;
                    case 1:
                        happy_expression2();
                        happy_mood ++;
                        break;
                    case 2:
                        happy_expression3();
                        happy_mood++;
                        break;
                    case 3:
                        happy_expression4();
                        happy_mood++;
                        break;
                    case 4:
                        happy_expression5();
                        happy_mood = 0;
                        break;                        
                }
                break;
                
            case HAPPY_N:
                 //clear corresponding part
                matrix_fillRect(0, 5, 20, 12, matrix_color333(0, 0, 0));
                matrix_fillRect(25, 0, 7, 7, matrix_color333(0, 0, 0));
                //draw face on the corner to show the current select mode
                draw_happy_face(28, 3, matrix_color333(0, 7, 0), matrix_color333(7, 7, 7));
                draw_pet(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 7, 7));
                draw_pet_happy_face(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 7, 0), matrix_color333(7, 7, 0));
                move_feet(fixed_face_position_x, fixed_face_position_y + 9, matrix_color333(7, 7, 7));
                move_right_hand(fixed_face_position_x + 8, fixed_face_position_y + 7, fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 7));
                move_left_hand(fixed_face_position_x, fixed_face_position_y + 7, fixed_face_position_x - 1, fixed_face_position_y, matrix_color333(7, 0, 7));
                 //if temperature in Celsius is over 26 or the BPM is over 125, change to TIRED or EXCITED mode
                if (temperature > 26) mood_select = 5;
                else if(BPM > 125)  mood_select = 4;
                //wait for 15 seconds to change back to neutral mode
                else {
                    if (neu_happy == 30) {
                        neu_happy = 0;
                        mood_select = 2;
                    } else neu_happy++;
                }
                //animation for firework using FSM
                switch (happy_mood) {
                    case 0:
                        happy_expression1();
                        happy_mood++;
                        break;
                    case 1:
                        happy_expression2();
                        happy_mood ++;
                        break;
                    case 2:
                        happy_expression3();
                        happy_mood++;
                        break;
                    case 3:
                        happy_expression4();
                        happy_mood++;
                        break;
                    case 4:
                        happy_expression5();
                        happy_mood = 0;
                        break;                        
                }
                break;

            case SAD:
                 //clear corresponding part
                matrix_fillRect(0, 5, 20, 12, matrix_color333(0, 0, 0));
                matrix_fillRect(25, 0, 7, 7, matrix_color333(0, 0, 0));
                //draw face on the corner to show the current select mode
                draw_sad_face(28, 3, matrix_color333(0, 0, 7), matrix_color333(7, 7, 0));
                draw_pet(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 7, 7));
                draw_pet_sad_face(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 7), matrix_color333(7, 0, 7));
                move_feet(fixed_face_position_x, fixed_face_position_y + 9, matrix_color333(7, 7, 7));
                move_right_hand(fixed_face_position_x + 8, fixed_face_position_y + 7, fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 7));
                move_left_hand(fixed_face_position_x, fixed_face_position_y + 7, fixed_face_position_x - 1, fixed_face_position_y, matrix_color333(7, 0, 7));
                 //if temperature in Celsius is over 26 or the BPM is over 125, change to TIRED or EXCITED mode
                if (temperature > 26) mood_select = 5;
                else if(BPM > 125)  mood_select = 4;
                 //animation for tear using FSM
                switch (sad_mood) {
                    case 0:
                        draw_pet_sad_expression1();
                        sad_mood++;
                        break;
                    case 1:
                        draw_pet_sad_expression2();
                        sad_mood++;
                        break;
                    case 2:
                        draw_pet_sad_expression3();
                        sad_mood = 0;
                        break;
                }

                break;
            case NEUTRAL:
                 //clear corresponding part
                matrix_fillRect(0, 5, 20, 12, matrix_color333(0, 0, 0));
                matrix_fillRect(25, 0, 7, 7, matrix_color333(0, 0, 0));
                draw_neutral_face(28, 3, matrix_color333(0, 7, 0), matrix_color333(7, 7, 7));
                draw_pet(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 7, 7));
                draw_pet_neutral_face(fixed_face_position_x, fixed_face_position_y, matrix_color333(0, 7, 0), matrix_color333(0, 7, 0));
                move_feet(fixed_face_position_x, fixed_face_position_y + 9, matrix_color333(7, 7, 7));
                move_right_hand(fixed_face_position_x + 8, fixed_face_position_y + 7, fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 7));
                move_left_hand(fixed_face_position_x, fixed_face_position_y + 7, fixed_face_position_x - 1, fixed_face_position_y, matrix_color333(7, 0, 7));
                 //if temperature in Celsius is over 26 or the BPM is over 125, change to TIRED or EXCITED mode
                if (temperature > 26) mood_select = 5;
                else if(BPM > 125)  mood_select = 4;
                //wait for 15 seconds to change to happy_n mode
                else {
                    if (neu_happy == 30) {
                        neu_happy = 0;
                        mood_select = 6;
                    } else neu_happy++;
                }
                break;

            case ANGRY:
                 //clear corresponding part
                matrix_fillRect(0, 5, 20, 12, matrix_color333(0, 0, 0));
                matrix_fillRect(25, 0, 7, 7, matrix_color333(0, 0, 0));
                draw_angry_face(28, 3, matrix_color333(7, 7, 7), matrix_color333(7, 0, 0));
                draw_pet(fixed_face_position_x, face_position_y, matrix_color333(7, 7, 7));
                draw_pet_angry_face(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 0), matrix_color333(7, 0, 0));
                move_feet(fixed_face_position_x, fixed_face_position_y + 9, matrix_color333(7, 7, 7));
                move_right_hand(fixed_face_position_x + 8, fixed_face_position_y + 7, fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 7));
                move_left_hand(fixed_face_position_x, fixed_face_position_y + 7, fixed_face_position_x - 1, fixed_face_position_y, matrix_color333(7, 0, 7));
                ang_time++;
                 //if temperature in Celsius is over 26 or the BPM is over 125, change to TIRED or EXCITED mode
                if (temperature > 26) mood_select = 5;
                else if(BPM > 125)  mood_select = 4;
                //animation for angry expression
                if (ang_time < 2) {
                    matrix_fillRect(0, 5, 5, 5, matrix_color333(0, 0, 0));
                    matrix_fillRect(14, 5, 5, 5, matrix_color333(0, 0, 0));
                } else {
                    draw_pet_angry_expression();
                    if (ang_time == 2) {
                        ang_time = 0;
                    }
                }
                break;
//when the temperature in Celsius is higher than 26 , the pet is in TIRED mode
            case SLEEP:
                 //clear corresponding part
                matrix_fillRect(0, 5, 20, 12, matrix_color333(0, 0, 0));
                matrix_fillRect(25, 0, 7, 7, matrix_color333(0, 0, 0));
                //the pet is not moving
                draw_pet(fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 7, 7));
                draw_pet_tired_face(fixed_face_position_x, fixed_face_position_y, matrix_color333(0, 7, 0), matrix_color333(0, 7, 0));
                move_feet(fixed_face_position_x, fixed_face_position_y + 9, matrix_color333(7, 7, 7));
                move_right_hand(fixed_face_position_x + 8, fixed_face_position_y + 7, fixed_face_position_x, fixed_face_position_y, matrix_color333(7, 0, 7));
                move_left_hand(fixed_face_position_x, fixed_face_position_y + 7, fixed_face_position_x - 1, fixed_face_position_y, matrix_color333(7, 0, 7));
                //draw additional tired expression 
                draw_pet_tired_expression();
                //back to neutral mood
                if (temperature < 26) mood_select = 2;
                //if heart rate is larger than 125, go to excited mode
                else if(BPM > 125)  mood_select = 4;
                break;
        }

        if (temp_state == 1) {
            //print Temperature in Celsius
            matrix_fillRect(21, 8, 15, 5, matrix_color333(0, 0, 0));
            matrix_setTextColor(matrix_color333(7, 7, 7));
            matrix_setCursor(21, 8); 
            matrix_setTextSize(1); 
            matrix_setTextWrap(false); 
            matrix_setTextColor(matrix_color333(7, 7, 7));
            matrix_write3x5String(temp);
            matrix_setCursor(29, 8); 
            matrix_setTextSize(1); 
            matrix_write3x5String("C"); //hard print out C 
        } else {
            //print Temperature in Fahrenheit
            matrix_fillRect(21, 8, 15, 5, matrix_color333(0, 0, 0));
            matrix_setTextColor(matrix_color333(7, 7, 7));
            matrix_setCursor(21, 8); 
            matrix_setTextSize(1); 
            matrix_setTextWrap(false); 
            matrix_setTextColor(matrix_color333(7, 7, 7));
            matrix_write3x5String(temp_f);
            matrix_setCursor(29, 8); 
            matrix_setTextSize(1); 
            matrix_write3x5String("F"); //hard print out F
        }

        //Print Heart rate when beat is complete and BPM is available
        if ((BPMTiming == 1) && (Signal < LowerThreshold)) {
            matrix_fillRect(0, 0, 16, 5, matrix_color333(0, 0, 0));
            matrix_setCursor(0, 0); 
            matrix_setTextSize(1); 
            matrix_setTextWrap(false); 
            matrix_setTextColor(matrix_color333(7, 7, 7));
            matrix_write3x5String(buffer);
            sys_time++;
            //refresh every second
            if (sys_time < 2) {
                matrix_fillRect(17, 0, 7, 6, matrix_color333(0, 0, 0));
            } else {
                draw_heart(18, 0, matrix_color333(7, 0, 0));
                if (sys_time == 2) {
                    sys_time = 0;
                }
            }
        }


    }
    PT_END(pt);
}

//// === Read heartrate Thread ====================================================

static PT_THREAD(protothread_heart(struct pt *pt)) {
    PT_BEGIN(pt);
    while (1) {
        // yield time 1 msec
        PT_YIELD_TIME_msec(1);
        //track running time 
        i++;   
         //read analog value from the pin using ADC converter
        Signal = readADC(HEARTAN);
        //if analog value is larger than upper threshold
        //beat is active
        if (Signal > UpperThreshold) {
            if (BeatComplete == 1) {
                BPM = i - lastTime;
                //conversion formula
                BPM = 60000 / BPM;
                BPMTiming = 0;
                BeatComplete = 0;
            }
            if (BPMTiming == 0) {
                //time stamp               
                lastTime = i;
                BPMTiming = 1;
            }
        }
        if ((BPMTiming == 1) && (Signal < LowerThreshold)) {
            //beat is inactive
            BeatComplete = 1;
            //print the result to character buffer
            sprintf(test, "%3d", Signal);
            sprintf(buffer, "%3d", BPM);
        }
    }
    PT_END(pt);
}

//// === Read temperature Thread ====================================================
static PT_THREAD(protothread_read_temperature(struct pt *pt)) {
    PT_BEGIN(pt);
    while (1) {
        PT_YIELD_TIME_msec(1);
        //read analog value from the pin using ADC converter
        temp_signal = readADC(TEMPAN);
        //convert from analog value to Celsius 
        temperature = (temp_signal * 0.32) - 50;
        //print temperature to character buffer 
        sprintf(temp, "%2.0f", temperature);
        //convert Celsius to Fahrenheit
        temperature_fahrenheit = (temperature * 1.8) + 32.0;
        //print Fahrenheit temperature to character buffer 
        sprintf(temp_f, "%2.0f", temperature_fahrenheit);
    }
    PT_END(pt);
}
//// === Read change temp mode Thread ====================================================
static PT_THREAD(protothread_changetemp(struct pt *pt)) {
    PT_BEGIN(pt);
    while (1) {
        // yield time 1 msec
        PT_YIELD_TIME_msec(1);
        //read button value 
        button_change = PORTAbits.RA4;
        //debounce the mood button
        switch (button_chage_state) {
            case NoPush_t:
                if (button_change) button_chage_state = MaybePush;
                else button_chage_state = NoPush;
                break;
            case MaybePush_t:
                if (button_change) {
                    //true button pressing
                    //change the temperature mode
                    if (temp_state == 0) temp_state = 1;
                    else temp_state = 0;
                    button_chage_state = Pushed;
                } else button_chage_state = NoPush;
                break;
            case Pushed_t:
                //if released, available to register next button input
                if (!button_change) button_chage_state = NoPush;
                else button_chage_state = Pushed;
                break;
        }

    }
    PT_END(pt);
}
//// === Read mood Thread ====================================================
static PT_THREAD(protothread_mood(struct pt *pt)) {
    PT_BEGIN(pt);
    while (1) {
        // yield time 1 msec
        PT_YIELD_TIME_msec(1);
        //read digital button input from the pin
        button_input = PORTBbits.RB11;
        //debounce the mood_select
        switch (button_state) {
            case NoPush:
                if (button_input) button_state = MaybePush;
                else button_state = NoPush;
                break;
            case MaybePush:
                if (button_input) {
                    //true button press is asserted
                    //if index number is the maximum index (3) change index back to 0
                    if (mood_select == 3) mood_select = 0;
                    //if it is in tired mode, stay in the mode
                    else if (mood_select == 5) mood_select = 5;
                     //if it is in excited mode, stay in the mode
                    else if (mood_select == 4) mood_select = 4;
                    //if it is in happy_n mode, mood_select to neutral
                    else if (mood_select == 6) mood_select = 3;
                    //change mode by change index number
                    else mood_select++;
                    neu_happy = 0;
                    button_state = Pushed;
                } else button_state = NoPush;               
                break;
            case Pushed:
                if (!button_input) button_state = NoPush;
                else button_state = Pushed;
                break;
        }

    }
    PT_END(pt);
}

// === Main  ===================================================================

void main(void) {

    SYSTEMConfig(SYSCLK, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);

    //set analog input for heartbeat sensor and temperature sensor
    mPORTBSetPinsAnalogIn(HEART | TEMP);

    INTDisableInterrupts();
    configureADC();

    matrix_init(1);
    
 // === setup system wide interrupts  ========
    INTEnableSystemMultiVectoredInt();
    mPORTBSetPinsDigitalIn(BIT_11);
    mPORTASetPinsDigitalIn(BIT_4);
    //configure internal resistance
    CNPDB = (1 << _CNPDB_CNPDB11_POSITION );
    CNPDA = (1 << _CNPDA_CNPDA4_POSITION );
    PT_setup();

    PT_INIT(&pt_update_matrix);
    PT_INIT(&pt_mood);
    PT_INIT(&pt_heart);
    PT_INIT(&pt_read_temperature);
    PT_INIT(&pt_changetemp);

    while (1) {
        PT_SCHEDULE(protothread_heart(&pt_heart));
        PT_SCHEDULE(protothread_mood(&pt_mood));
        PT_SCHEDULE(protothread_read_temperature(&pt_read_temperature));
        PT_SCHEDULE(protothread_update_matrix(&pt_update_matrix));
        PT_SCHEDULE(protothread_changetemp(&pt_changetemp));
    }
}
// === end  ======================================================

